//
//  BaseChooseViewController.h
//  RealEstateManagement
//
//  Created by Javen on 16/9/7.
//  Copyright © 2016年 上海勾芒信息科技. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "BaseChooseModel.h"

@interface BaseChooseViewController : BaseViewController<UITableViewDelegate, UITableViewDataSource, UISearchBarDelegate>
@property (nonatomic, copy) NSString *navTitle;
/**
 *  分页加载时记录当前页数
 */
@property (nonatomic, assign) NSInteger page;
/**
 *  每次加载的个数
 */
@property (nonatomic, assign) NSInteger pageSize;
/**
 *  导航栏标题
 */
@property (weak, nonatomic) IBOutlet UILabel *navigationTitle;
@property (weak, nonatomic) IBOutlet UISearchBar *searchBar;
@property (weak, nonatomic) IBOutlet UITableView *tableView;
@property (nonatomic, strong) NSMutableArray *arrData;
@property (nonatomic, copy) void (^blockChoose)(id carrier);
@property (nonatomic, copy) NSString *searchText;
@property (nonatomic, strong) NSArray *displayDataArr;
@property (nonatomic, assign) BOOL isPageMode;


- (IBAction)actionBac:(id)sender;

/**
 *  启用分页加载（同时需要重写searchBar:textDidChange:方法）
 */
- (void)paggingMode;

/**
 *  请求数据要重写这个方法，在这个方法里面请求数据，获取数据后调用showData方法，展示获取到的数据
 */
- (void)httpRequest;

/**
 *  结束刷新并获取到的数据
 */
- (void)showData;
/**
 *
 */
- (void)disableRefresh;
/**
 *  下拉刷新
 */
- (void)refresh;
@end
